#pragma once
#include <Arduino.h>
#include <set>
#include <vector>
class Users
{
public:
    enum ATTRIBUTES{
        FIRST_NAME,
        LAST_NAME,
        RFID_UID,
        USER_PIN
    };
    typedef struct User
    {
        unsigned long uid;
        String first_name;
        String last_name;
        String rfid_uid;
        String user_pin;
        bool operator < (const User &o) const { return uid <o.uid; }
        bool operator == (const User &o) const { return uid ==o.uid; }
    } user_account;

private:
    std::set<User> _userdb;

    /* data */
public:
    Users(/* args */);
    ~Users();
    bool checkRfid(String rfid_code, std::vector<Users::User> *logon_users);
    bool checkPin(String pin_code, std::vector<Users::User> *logon_users);
    bool addUser(unsingend long id, String first_name, String last_name, String rifd_uid, String user_pin);
    bool delUser(unsingend long id);
    bool updateUser(unsingend long id, ATTRIBUTES attr, String value);
};